package com.fjhx.xmhjc.service.topic.impl;

import com.fjhx.xmhjc.entity.product.vo.ProductCategoryVo;
import com.fjhx.xmhjc.entity.topic.po.TopicContent;
import com.fjhx.xmhjc.mapper.topic.TopicContentMapper;
import com.fjhx.xmhjc.service.topic.TopicContentService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.xmhjc.entity.topic.vo.TopicContentVo;
import com.fjhx.xmhjc.entity.topic.dto.TopicContentSelectDto;
import com.ruoyi.common.utils.wrapper.IWrapper;
import com.fjhx.xmhjc.entity.topic.dto.TopicContentDto;
import cn.hutool.core.bean.BeanUtil;

import java.util.List;

/**
 * <p>
 * 内容主题 服务实现类
 * </p>
 *
 * @author hj
 * @since 2023-11-20
 */
@Service
public class TopicContentServiceImpl extends ServiceImpl<TopicContentMapper, TopicContent> implements TopicContentService {

    @Override
    public List<TopicContentVo> getList(TopicContentSelectDto dto) {
        IWrapper<TopicContent> wrapper = getWrapper();
        wrapper.orderByDesc("tc", TopicContent::getId);
        List<TopicContentVo> list = this.baseMapper.getList(wrapper);
        return list;
    }

    @Override
    public Page<TopicContentVo> getPage(TopicContentSelectDto dto) {
        IWrapper<TopicContent> wrapper = getWrapper();
        wrapper.orderByDesc("tc", TopicContent::getId);
        Page<TopicContentVo> page = this.baseMapper.getPage(dto.getPage(), wrapper);
        return page;
    }

    @Override
    public TopicContentVo detail(Long id) {
        TopicContent TopicContent = this.getById(id);
        TopicContentVo result = BeanUtil.toBean(TopicContent, TopicContentVo.class);
        return result;
    }

    @Override
    public void add(TopicContentDto topicContentDto) {
        this.save(topicContentDto);
    }

    @Override
    public void edit(TopicContentDto topicContentDto) {
        this.updateById(topicContentDto);
    }

    @Override
    public void delete(Long id) {
        this.removeById(id);
    }


    @Override
    public Page<TopicContentVo> contentPage(TopicContentSelectDto dto) {
        IWrapper<TopicContent> wrapper = getWrapper();
        wrapper.orderByDesc("tc", TopicContent::getToping);
        wrapper.orderByDesc("tc", TopicContent::getId);
        Page<TopicContentVo> page = this.baseMapper.getPage(dto.getPage(), wrapper);
        return page;
    }
}
